/*
** Copyright (C) 1993-2013 Mark B. Hanson (mbh@panix.com)
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// @(#)$Id: tthing.h 1344 2013-04-05 21:18:39Z mark $

#ifdef	XSC_TTHING_H

class Tthing;

#else	// XSC_TTHING_H
#define	XSC_TTHING_H

#include "thing.h"

class Tthing : virtual public Thing {
protected:
    float theta;
    float dtheta;

public:
    Tthing(void);
    virtual ~Tthing(void);

    float get_theta(void) const;
    void set_theta(const float);

    float get_dtheta(void) const;
    void set_dtheta(const float);

    virtual void set_xpoints(void);
    virtual void turn(void);
};


inline float
Tthing::get_theta(void) const
{
    return theta;
} // Tthing::get_theta


inline void
Tthing::set_theta(const float ntheta)
{
    theta = ntheta;
} // Tthing::get_theta


inline float
Tthing::get_dtheta(void) const
{
    return dtheta;
} // Tthing::get_theta


inline void
Tthing::set_dtheta(const float ndtheta)
{
    dtheta = ndtheta;
} // Tthing::get_theta

#endif	// XSC_TTHING_H
